- block:
  - name: "install manifest {{ item.file }}"
    command: "kubectl apply -f -"
    args:
      stdin: "{{ lookup('template', 'templates/manifests/'+item.file) }}"
    changed_when: False
    when: item.file is defined and not item.delete | default(False) | bool
    register: kubectl_apply

  - name: "delete manifest {{ item.file }}"
    command: "kubectl delete -f -"
    args:
      stdin: "{{ lookup('template', 'templates/manifests/'+item.file) }}"
    changed_when: False
    when: item.file is defined and item.delete | default(False) | bool
    register: kubectl_apply

  - name: "install manifest {{ item.url }}"
    command: "kubectl apply -f {{ item.url }}"
    changed_when: False
    when: item.url is defined and not item.delete | default(False) | bool
    register: kubectl_apply

  - name: "delete manifest {{ item.url }}"
    command: "kubectl delete -f {{ item.url }}"
    changed_when: False
    when: item.url is defined and item.delete | default(False) | bool
    register: kubectl_apply

  tags: manifests
  rescue:
    - debug:
        msg: "stderr: {{ kubectl_apply.stderr | default('') }}"
      when: kubectl_apply.failed

    - debug:
        msg: "{{ lookup('template', 'templates/manifests/'+item.file).split('\n') }}"
      when: kubectl_apply.failed

    - name: "upload manifest {{ item.file }}"
      template:
        src: "templates/manifests/{{ item.file }}"
        dest: "/tmp/{{ item.file | basename }}"
      when: item.file is defined and item.keepfile is defined
